close all;clear all
gr=groot;gr.ShowHiddenHandles='on';
fig=uifigure;
sub22(1)=uiaxes(fig);
sub22(2)=uiaxes(fig);
sub22(3)=uiaxes(fig);
sub22(4)=uiaxes(fig);
%set(sub22(1),'Units','normalized','Position',[0.1300 0.5838 0.3347 0.3412])
set(sub22(1),'Units','pixels','Position',[73.8000 246.2116 187.4091 143.2884])
set(sub22(2),'Units','pixels','Position',[320.3909 246.2116 187.4091 143.2884])
set(sub22(3),'Units','pixels','Position',[73.8000 47.2000 187.4091 143.2884])
set(sub22(4),'Units','pixels','Position',[320.3909 47.2000 187.4091 143.2884])


viewagl=[-37.5,30;0,90;90,0;0,0];
n=46;
l=[zeros(2,n);2*ones(1,n)];
lg=l/2;%重心位置
th=zeros(1,n);
%同次変換座標行列の定義より、arm(1)の重心lgは、関節が動いてもlgの位置には作用しない。
for i=[1,3:10]
	arm(i).th=th(i);arm(i).a=[0;0;1];arm(i).l=l(:,1);arm(i).lg=lg(:,1);
end
for i=[2,10:n]
	arm(i).th=th(i);arm(i).a=[1;0;0];arm(i).l=l(:,1);arm(i).lg=lg(:,1);
end
%骨組み
arm(1).l=[0;0;0];
arm(2).l=[-3;0;0]; %先端
arm(3).l=[0;0;-9];

%足
arm(4).l=[5;5;-0.5];
arm(5).l=[-5;5;-0.5];
arm(6).l=[5;-5;-0.5];
arm(7).l=[-5;-5;-0.5];

%プロペラ
arm(8).l=[0;0;6];
arm(9).l=[0;6*1.7/2;-6/2];
arm(10).l=[0;-6*1.7/2;-6/2];

%カバー
arm(11).l=[-3;0;7.5];
arm(12).l=[-3;0;-7.5];
arm(13).l=[-3;0;-7.5];
arm(14).l=[-3;0;7.5];
arm(15).l=[-3;7.5;0];
arm(16).l=[-3;-7.5;0];
arm(17).l=[-3;-7.5;0];
arm(18).l=[-3;7.5;0];
arm(19).l=[-3;7.5/2;7.5*1.7/2];
arm(20).l=[-3;-7.5/2;-7.5*1.7/2];
arm(21).l=[-3;-7.5/2;-7.5*1.7/2];
arm(22).l=[-3;7.5/2;7.5*1.7/2];
arm(23).l=[-3;7.5*1.7/2;7.5/2];
arm(24).l=[-3;-7.5*1.7/2;-7.5/2];
arm(25).l=[-3;-7.5*1.7/2;-7.5/2];
arm(26).l=[-3;7.5*1.7/2;7.5/2];
arm(27).l=[-3;7.5/2;-7.5*1.7/2];
arm(28).l=[-3;-7.5/2;7.5*1.7/2];
arm(29).l=[-3;-7.5/2;7.5*1.7/2];
arm(30).l=[-3;7.5/2;-7.5*1.7/2];
arm(31).l=[-3;7.5*1.7/2;-7.5/2];
arm(32).l=[-3;-7.5*1.7/2;7.5/2];
arm(33).l=[-3;-7.5*1.7/2;7.5/2];
arm(34).l=[-3;7.5*1.7/2;-7.5/2];
arm(35).l=[0;7.5/2;7.5*1.7/2-7.5];
arm(36).l=[0;7.5*1.7/2-7.5/2;7.5/2-7.5*1.7/2];
arm(37).l=[0;7.5-7.5*1.7/2;-7.5/2];
arm(38).l=[0;-7.5/2;7.5*1.7/2-7.5];
arm(39).l=[0;-7.5*1.7/2+7.5/2;7.5/2-7.5*1.7/2];
arm(40).l=[0;-7.5+7.5*1.7/2;-7.5/2];%%%
arm(41).l=[0;-7.5/2;-7.5*1.7/2+7.5];
arm(42).l=[0;-7.5*1.7/2+7.5/2;-7.5/2+7.5*1.7/2];
arm(43).l=[0;-7.5+7.5*1.7/2;7.5/2];
arm(44).l=[0;7.5/2;-7.5*1.7/2+7.5];
arm(45).l=[0;7.5*1.7/2-7.5/2;-7.5/2+7.5*1.7/2];
arm(46).l=[0;7.5-7.5*1.7/2;7.5/2];

arm(1).parent=0;arm(2).parent=1;arm(3).parent=1; %骨組み
arm(4).parent=3;arm(5).parent=3;arm(6).parent=3;arm(7).parent=3; %足
arm(8).parent=2;arm(9).parent=2;arm(10).parent=2; %回転部分
arm(11).parent=1;arm(12).parent=11;arm(13).parent=1;arm(14).parent=13; %カバー
arm(15).parent=1;arm(16).parent=15;arm(17).parent=1;arm(18).parent=17;
arm(19).parent=1;arm(20).parent=19;arm(21).parent=1;arm(22).parent=21;
arm(23).parent=1;arm(24).parent=23;arm(25).parent=1;arm(26).parent=25;
arm(27).parent=1;arm(28).parent=27;arm(29).parent=1;arm(30).parent=29;
arm(31).parent=1;arm(32).parent=31;arm(33).parent=1;arm(34).parent=33;
arm(35).parent=11;arm(36).parent=35;arm(37).parent=36;
arm(38).parent=11;arm(39).parent=38;arm(40).parent=39;
arm(41).parent=13;arm(42).parent=41;arm(43).parent=42;
arm(44).parent=13;arm(45).parent=44;arm(46).parent=45;

% 子リンクを接続し双方向リンクとする。
arm=vectest9makechildlink(arm);

ind=vectest9findallchildren(arm);
arm=vectest9kinematics(arm,ind);
plot1=[];
plot1=vectest9plot2021(arm,plot1,sub22)
fig2=uifigure;
ui=vectest9makeui2021(arm,'vectest9sub2021',fig2)
b1=uibutton(fig2,'Position',[300,100,60,60]);b2=uibutton(fig2,'Position',[300,30,60,60]);
b1.Text='rotation';b2.Text='swing';
b1.ButtonPushedFcn='motion=''kaiten'';kaiten';
b2.ButtonPushedFcn='motion=''swing'';kaiten';